/*
* Copyright (c) 2012 by naehrwert
* This file is released under the GPLv2.
*/

#include "types.h"
#include "aes.h"

// encdec data key seed
u8 encdec_seed_00[] =
{
	0xE2, 0xD0, 0x5D, 0x40, 0x71, 0x94, 0x5B, 0x01, 0xC3, 0x6D, 0x51, 0x51, 0xE8, 0x8C, 0xB8, 0x33,
  0x4A, 0xAA, 0x29, 0x80, 0x81, 0xD8, 0xC4, 0x4F, 0x18, 0x5D, 0xC6, 0x60, 0xED, 0x57, 0x56, 0x86
};

// encdec tweak key seed
u8 encdec_seed_20[] =
{
	0x02, 0x08, 0x32, 0x92, 0xC3, 0x05, 0xD5, 0x38, 0xBC, 0x50, 0xE6, 0x99, 0x71, 0x0C, 0x0A, 0x3E,
  0x55, 0xF5, 0x1C, 0xBA, 0xA5, 0x35, 0xA3, 0x80, 0x30, 0xB6, 0x7F, 0x79, 0xC9, 0x05, 0xBD, 0xA3
};

// sb indiv seed 0x00-0x1F
u8 sb_indiv_seed_00[] =
{
	0xD9, 0x2D, 0x65, 0xDB, 0x05, 0x7D, 0x49, 0xE1, 0xA6, 0x6F, 0x22, 0x74, 0xB8, 0xBA, 0xC5, 0x08,
  0x83, 0x84, 0x4E, 0xD7, 0x56, 0xCA, 0x79, 0x51, 0x63, 0x62, 0xEA, 0x8A, 0xDA, 0xC6, 0x03, 0x26
};

// sb indiv seed 0x20-0x3F
u8 sb_indiv_seed_20[] =
{
	0xC3, 0xB3, 0xB5, 0xAA, 0xCC, 0x74, 0xCD, 0x6A, 0x48, 0xEF, 0xAB, 0xF4, 0x4D, 0xCD, 0xF1, 0x6E,
  0x37, 0x9F, 0x55, 0xF5, 0x77, 0x7D, 0x09, 0xFB, 0xEE, 0xDE, 0x07, 0x05, 0x8E, 0x94, 0xBE, 0x08
};

// arcade encdec data key seed, ARCADE_ENCDEC_data_keyseed
u8 arc_encdec_seed_00[] =
{
	0xD2, 0xBC, 0xFF, 0x74, 0x2D, 0x57, 0x1A, 0x80, 0xDF, 0xEE, 0x5E, 0x24, 0x96, 0xD1, 0x9C, 0x3A,
  0x6F, 0x25, 0xFA, 0x0F, 0xC6, 0x97, 0x64, 0xCA, 0xC2, 0x0F, 0x42, 0x69, 0xEB, 0x54, 0x0F, 0xD8
};

// arcade encdec tweak key seed, ARCADE_ENCDEC_tweak_keyseed
u8 arc_encdec_seed_20[] =
{
	0xC1, 0x9C, 0x7F, 0x98, 0x7E, 0xDB, 0x6E, 0x24, 0x4B, 0x07, 0xBE, 0xDE, 0xFA, 0x1E, 0x6C, 0xC9,
  0xF0, 0x85, 0x24, 0xD9, 0x8C, 0x05, 0x65, 0x4C, 0xC7, 0x42, 0x14, 0x1E, 0x01, 0xF8, 0x23, 0xE1
};

// sb indiv seed 0x00-0x1F, ARCADE_ATA_data_tweak_keyseed
u8 arc_sb_indiv_seed_00[] =
{
	0xDA, 0x73, 0xED, 0x90, 0x20, 0x91, 0x8F, 0x4C, 0x0A, 0x70, 0x3D, 0xCC, 0xF8, 0x90, 0x61, 0x7B,
  0xFF, 0xD2, 0x5E, 0x33, 0x40, 0x00, 0x91, 0x09, 0x58, 0x3C, 0x64, 0x3D, 0xF4, 0xA2, 0x13, 0x24
};

// sb indiv seed 0x20-0x3F
u8 arc_sb_indiv_seed_20[] =
{
	0xDA, 0x73, 0xED, 0x90, 0x20, 0x91, 0x8F, 0x4C, 0x0A, 0x70, 0x3D, 0xCC, 0xF8, 0x90, 0x61, 0x7B,
  0xFF, 0xD2, 0x5E, 0x33, 0x40, 0x00, 0x91, 0x09, 0x58, 0x3C, 0x64, 0x3D, 0xF4, 0xA2, 0x13, 0x24
};

// arc_eid_root_key
u8 arc_eid_root_key[] =
{
	0x35, 0x9F, 0x59, 0xBB, 0x8C, 0x25, 0x6B, 0x91, 0x09, 0x3A, 0x92, 0x00, 0x72, 0x03, 0xAB, 0xB3,
  0x3B, 0xAD, 0xF5, 0xAC, 0x09, 0xA0, 0xDC, 0x00, 0x58, 0x59, 0xD6, 0xF1, 0x59, 0xC4, 0xF5, 0x4F
};

// arc_eid_root_iv
u8 arc_eid_root_iv[] =
{
	0x92, 0x92, 0x14, 0xD8, 0xFC, 0xCB, 0x4C, 0xE7, 0x09, 0x9A, 0xCE, 0xBD, 0xFC, 0x66, 0x12, 0xB9
};        



void generate_ata_keys(u8 *eid_root_key, u8 *eid_root_iv, u8 *data_key_dst, u8 *tweak_key_dst)
{
	s32 i;
	u8 isARC = 1;
	aes_context aes_ctxt;
	u8 iv[0x10];
	
	for(i = 0; i < 32; i++)
	  if(eid_root_key[i] != arc_eid_root_key[i])
	    isARC = 0;
  
  if(isARC) {
		//Generate arcade ATA data key.
	  aes_setkey_enc(&aes_ctxt, arc_eid_root_key, 256);
	  memcpy(iv, arc_eid_root_iv, 16);
	  aes_crypt_cbc(&aes_ctxt, AES_ENCRYPT, 0x20, iv, arc_sb_indiv_seed_00, data_key_dst);
	  
	  //Generate arcade ATA tweak key.
	  aes_setkey_enc(&aes_ctxt, eid_root_key, 256);
	  memcpy(iv, eid_root_iv, 16);
	  aes_crypt_cbc(&aes_ctxt, AES_ENCRYPT, 0x20, iv, arc_sb_indiv_seed_20, tweak_key_dst);
	}
	else {
    //Generate ATA data key.
	  aes_setkey_enc(&aes_ctxt, eid_root_key, 256);
	  memcpy(iv, eid_root_iv, 16);
	  aes_crypt_cbc(&aes_ctxt, AES_ENCRYPT, 0x20, iv, sb_indiv_seed_00, data_key_dst);
	  
	  //Generate ATA tweak key.
	  aes_setkey_enc(&aes_ctxt, eid_root_key, 256);
	  memcpy(iv, eid_root_iv, 16);
	  aes_crypt_cbc(&aes_ctxt, AES_ENCRYPT, 0x20, iv, sb_indiv_seed_20, tweak_key_dst);
	}
}

void generate_encdec_keys(u8 *eid_root_key, u8 *eid_root_iv, u8 *data_key_dst, u8 *tweak_key_dst)
{
	s32 i;
	u8 isARC = 1;
	aes_context aes_ctxt;
	u8 iv[0x10];
	
	for(i = 0; i < 32; i++)
	  if(eid_root_key[i] != arc_eid_root_key[i])
	    isARC = 0;
  
  if(isARC) {
		//Generate encdec_k1.
	  aes_setkey_enc(&aes_ctxt, arc_eid_root_key, 256);
	  memcpy(iv, arc_eid_root_iv, 16);
	  aes_crypt_cbc(&aes_ctxt, AES_ENCRYPT, 0x20, iv, arc_encdec_seed_00, data_key_dst);
    
	  //Generate encdec_k3.
	  aes_setkey_enc(&aes_ctxt, eid_root_key, 256);
	  memcpy(iv, eid_root_iv, 16);
	  aes_crypt_cbc(&aes_ctxt, AES_ENCRYPT, 0x20, iv, arc_encdec_seed_20, tweak_key_dst);
	}
	else {
	  //Generate encdec_k1.
	  aes_setkey_enc(&aes_ctxt, eid_root_key, 256);
	  memcpy(iv, eid_root_iv, 16);
	  aes_crypt_cbc(&aes_ctxt, AES_ENCRYPT, 0x20, iv, encdec_seed_00, data_key_dst);
    
	  //Generate encdec_k3.
	  aes_setkey_enc(&aes_ctxt, eid_root_key, 256);
	  memcpy(iv, eid_root_iv, 16);
	  aes_crypt_cbc(&aes_ctxt, AES_ENCRYPT, 0x20, iv, encdec_seed_20, tweak_key_dst);
  }
}
